#!/usr/bin/env python2
# -*- coding: utf-8 -*-
##################################################
# GNU Radio Python Flow Graph
# Title: Top Block
# Generated: Tue Jan 10 09:56:30 2017
##################################################

from gnuradio import blocks
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio import uhd
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from optparse import OptionParser
import dkblocks
import research
import time
import tuner_helper  # embedded python module


class top_block(gr.top_block):

    def __init__(self):
        gr.top_block.__init__(self, "Top Block")

        ##################################################
        # Variables
        ##################################################
        self.spectrum_fft_size = spectrum_fft_size = 65536*16
        self.samp_rate = samp_rate = 10000000
        self.rx_gain = rx_gain = 14
        self.rx_frequency = rx_frequency = 85e6
        self.min_y = min_y = -140+80
        self.max_y = max_y = -80+60
        self.fft_size = fft_size = 512

        ##################################################
        # Blocks
        ##################################################
        self.uhd_usrp_source_0_0 = uhd.usrp_source(
        	",".join(("addr=192.168.10.3", '')),
        	uhd.stream_args(
        		cpu_format="fc32",
        		channels=range(1),
        	),
        )
        self.uhd_usrp_source_0_0.set_clock_source('external', 0)
        self.uhd_usrp_source_0_0.set_time_source('external', 0)
        self.uhd_usrp_source_0_0.set_samp_rate(samp_rate)
        self.uhd_usrp_source_0_0.set_center_freq(tuner_helper.int_n_tuning(rx_frequency), 0)
        self.uhd_usrp_source_0_0.set_gain(rx_gain, 0)
        self.research_serverSource_0 = research.serverSource()
        self.dkblocks_udpBroadcast_0 = dkblocks.udpBroadcast('192.168.10.4', 58, 'STOP')
        self.blocks_vector_sink_x_0 = blocks.vector_sink_f(1)
        self.blocks_file_sink_0 = blocks.file_sink(gr.sizeof_gr_complex*1, '/home/admin/Documents/GNURadio/Projects/CSPhase2/test.dat', False)
        self.blocks_file_sink_0.set_unbuffered(False)

        ##################################################
        # Connections
        ##################################################
        self.connect((self.research_serverSource_0, 0), (self.blocks_vector_sink_x_0, 0))
        self.connect((self.uhd_usrp_source_0_0, 0), (self.blocks_file_sink_0, 0))

    def get_spectrum_fft_size(self):
        return self.spectrum_fft_size

    def set_spectrum_fft_size(self, spectrum_fft_size):
        self.spectrum_fft_size = spectrum_fft_size

    def get_samp_rate(self):
        return self.samp_rate

    def set_samp_rate(self, samp_rate):
        self.samp_rate = samp_rate
        self.uhd_usrp_source_0_0.set_samp_rate(self.samp_rate)

    def get_rx_gain(self):
        return self.rx_gain

    def set_rx_gain(self, rx_gain):
        self.rx_gain = rx_gain
        self.uhd_usrp_source_0_0.set_gain(self.rx_gain, 0)


    def get_rx_frequency(self):
        return self.rx_frequency

    def set_rx_frequency(self, rx_frequency):
        self.rx_frequency = rx_frequency
        self.uhd_usrp_source_0_0.set_center_freq(tuner_helper.int_n_tuning(self.rx_frequency), 0)
        self.uhd_usrp_source_0_0.set_center_freq(self.rx_frequency, 1)

    def get_min_y(self):
        return self.min_y

    def set_min_y(self, min_y):
        self.min_y = min_y

    def get_max_y(self):
        return self.max_y

    def set_max_y(self, max_y):
        self.max_y = max_y

    def get_fft_size(self):
        return self.fft_size

    def set_fft_size(self, fft_size):
        self.fft_size = fft_size


def main(top_block_cls=top_block, options=None):

    tb = top_block_cls()
    tb.start()
    tb.wait()


if __name__ == '__main__':
    main()
